#include "../libssts/SimpleTypeSystem.h"
#include "callback.h"
#include "test_macros.h"

int
test_callback_test_func1 (SObject * obj, spointer user_data) {
  return 2;
}

spointer
test_callback_test_func2 (SObject * obj, sint * output) {
  s_print ("Hello from the callback!\n");
  *output = 1337;
  return NULL;
}

enum {
  TEST_CALLBACK1,
  TEST_CALLBACK2,
  TEST_CALLBACK_END
};

static SCallbackEntry * callback_entries[] = {NULL,};

int
test_callback (void) {
  setup_unit ();

  SObject * obj = s_object_new ();

  callback_entries[TEST_CALLBACK1] =
    s_callback_entry_new ("test1",
                          test_callback_test_func1,
                          S_CALLBACK_CALLBACK);

  callback_entries[TEST_CALLBACK2] =
    s_callback_entry_new ("test2",
                          CALLBACK(test_callback_test_func2)  ,
                          S_CALLBACK_CALLBACK);

  s_object_install_callbacks (obj, TEST_CALLBACK_END, callback_entries);

  test_case ((slong)s_object_notify (obj, "test1", NULL) == 2,
            "the output from the callback is the expected value");

  sint * output = s_malloc (sizeof (sint));

  s_object_notify (obj, "test2", (spointer)output);

  test_case (output !=  NULL, "The value that was givef vida the user_data"
                              " pointer is not null");

  test_case (*output == 1337, "The value that was given via the"
                              " user_data pointer has the corret"
                              " value");
  s_free (output);

  s_object_free (obj);

  end_unit ();
}
